VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2055
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3930
   LinkTopic       =   "Form1"
   ScaleHeight     =   2055
   ScaleWidth      =   3930
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDecimalValue 
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   1335
   End
   Begin VB.Label lblBinaryValue 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1560
      Width           =   3375
   End
   Begin VB.Label Label1 
      Caption         =   "Binary Value"
      Height          =   255
      Index           =   1
      Left            =   240
      TabIndex        =   2
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Decimal Value"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    txtDecimalValue.Text = "32000"
End Sub

Private Sub txtDecimalValue_KeyPress(KeyAscii As Integer)
    'Cancel input if the key pressed is not a number
    If IsNumeric(Chr(KeyAscii)) = False Then
        KeyAscii = 0
    End If
End Sub
Function Bin(Number) ' both Variants
' #Binary BITS# by Chris
' based on the Two's-Complement "shortcut" method
'===========================================
Dim BitStream() As Byte
Dim Bits As Byte
Dim BitPointer As Byte
Dim HexString As String
Dim lenHS As Integer
Dim HalfByte As Byte ' smallest VB word
Dim i As Integer
Dim j As Integer

Const DABug As Boolean = False
On Error GoTo eror

Select Case VarType(Number)
Case vbNull
'pass a null, return a null
 Bin = Number
 Exit Function
Case vbByte
' 0 to 255 unsigned
 Bits = 8
Case vbInteger, vbBoolean
' -32,768 to 32,767
 Bits = 16
Case vbLong
' -2,147,483,648 to 2,147,483,647
 Bits = 32
Case vbSingle, vbDouble
 Bits = 32
' HEX() will convert these
'  to Longs (if possible!)
Case vbString
'-a Number of unspecified Type-
''Note: This expects a String to be a Number
''  To get the bits for a String, try this code:
''Dim BS() As Byte
''BS = MyString '-or- BS = StrConv(MyString, vbFromUnicode)
''For i = LBound(BS) To UBound(BS)
''  Print Bin(BS(i)),
''Next i
Case Else
 Err.Raise 2001, , "Not sure HOW to handle a (" & TypeName(Number) & ") DATA TYPE?"
End Select

'' if HEX() can't handle it,
'' then neither can this code!
HexString = Hex(Number)
lenHS = Len(HexString)

If Bits = 0 Then Bits = lenHS * 4 'bits
ReDim BitStream(1 To Bits)
BitPointer = Bits

For i = lenHS To 1 Step -1
  HalfByte = Val("&H" & Mid(HexString, i, 1))
  For j = 1 To 4 ' bits
   If HalfByte Then
     BitStream(BitPointer) = HalfByte Mod 2
     HalfByte = Fix(HalfByte / 2)
   End If
   BitPointer = BitPointer - 1
  Next j
Next i

'now add 48 to all bits(bytes) for "0" or "1"
For i = 1 To Bits
  BitStream(i) = BitStream(i) + 48
Next i

Bin = StrConv(BitStream, vbUnicode)
' format it
Bin = Trim(Format(Bin, "&&&&&&&& &&&&&&&& &&&&&&&& &&&&&&&&"))
'(format it here?  or outside this proc?)
Exit Function

eror:
If DABug Then Debug.Print Err.Number & "-" & Err.Description
Err.Clear
Bin = "0"
End Function

Private Sub txtDecimalValue_Change()
    lblBinaryValue.Caption = Bin(txtDecimalValue.Text)
End Sub


